DROP DATABASE IF EXISTS `Provisioning`;

CREATE DATABASE `Provisioning`;

USE `Provisioning`;

CREATE TABLE `Customer_Devices_Provisioning` (
  ID                    INT(10) NOT NULL AUTO_INCREMENT,
  MAC_Address           VARCHAR(12) DEFAULT NULL,
  Account_ID            VARCHAR(11) NOT NULL,
  Device_Model          VARCHAR(30) NOT NULL,
  HTTP_Login            VARCHAR(30) DEFAULT NULL,
  HTTP_Password         VARCHAR(30) DEFAULT NULL,
  Subscrition_Date      DATETIME NOT NULL,
  Init_IP               VARCHAR(15) DEFAULT NULL,
  Init_Session_Id       VARCHAR(100),
  Init_Closing_Time     DATETIME DEFAULT NULL,
  Init_Session_Until    DATETIME DEFAULT NULL,
  Init_Date             DATETIME,
  First_Update          DATETIME,
  Last_Update           DATETIME,
  Count_Updates         INT(10) DEFAULT 0,
  i_account             INT(10) unsigned DEFAULT NULL,
  sha1_pass             VARCHAR(40) DEFAULT NULL,
  PRIMARY KEY           (ID),
  UNIQUE KEY            (MAC_Address),
  UNIQUE KEY            (HTTP_Login),
  KEY                   (Account_ID),
  KEY                   (Device_Model),
  KEY                   (Subscrition_Date)
);

CREATE TABLE `Customer_Devices_Provisioning_Values` (
  Device_ID         INT(10),
  Parameter_ID      varchar(10),
  Value             varchar(255),
  KEY        (Device_ID),
  KEY        (Parameter_ID),
  UNIQUE KEY (Device_ID,Parameter_ID)
);

CREATE TABLE `Customer_Devices_Provisioning_Parameters` (
  Parameter_ID      varchar(10),
  Device_Model      VARCHAR(30) NOT NULL,
  Description       TEXT,
  Default_Value     varchar(255),
  KEY        (Parameter_ID),
  UNIQUE KEY (Parameter_ID,Device_Model)
);

CREATE TABLE `Init_Provisioning_Steps` (
  ID                  INT(10) NOT NULL AUTO_INCREMENT,
  Steps_Order         INT(2) NOT NULL DEFAULT 1,
  Description         varchar(255),
  PRIMARY KEY         (ID),
  UNIQUE KEY          (Steps_Order)
);

CREATE TABLE Last_Accounts_Sha_Password (
  i_account INT(10) unsigned,
  sha1_pass VARCHAR(40),
  UNIQUE KEY (i_account)
);


CREATE TABLE Accounts_passwords (
  i_account INT(10) unsigned,
  password  VARCHAR(40),
  UNIQUE KEY (i_account)
);

CREATE TABLE Sip_Servers (
  name varchar(50),
  weight int(5),
  timestamp int(12),
  UNIQUE KEY (name)
);
