#!/usr/bin/perl

use strict;
use warnings;
use DBI;
use Storable;
use File::Spec::Functions qw(rel2abs);
use File::Basename;
use List::Util qw(min max);


my $dirname = dirname(rel2abs($0));
chdir $dirname;

my $pb_db   = "porta-billing";
my $pb_host = "xxx.xxx.xxx.xxx";
my $pb_user = "xxxxxxxxxxxxxxx";
my $pb_pass = "xxxxxxxxxxxxxxx";

my $pr_db   = "Provisioning";
my $pr_host = "xxx.xxx.xxx.xxx";
my $pr_user = "xxxxxxxxxxxxxxx";
my $pr_pass = "xxxxxxxxxxxxxxx";

my $timestamp = time;

my $pb_dbh = DBI->connect( "dbi:mysql:dbname=$pb_db;host=$pb_host;", $pb_user, $pb_pass ) or die "Connexion
impossible à la base de données $pb_db !";

my $pr_dbh = DBI->connect( "dbi:mysql:dbname=$pr_db;host=$pr_host;", $pr_user, $pr_pass ) or die "Connexion
impossible à la base de données $pr_db !";


my $active_nodes = {};

my $h1 = {};
my $h2 = {};
my $h3 = {};
my $h4 = {};
my $h5 = {};
my $h6 = {};

for (my $i = 1; $i <= 200; $i++) {
  my $t = `dig sip$i.youroute.net | grep CNAME | awk '{print \$1","\$5'}`;
  if ( $t =~ /([^,]+)\.[,]+([^,]+)\./ ){
    $h1->{$1} = $2;
    if ( defined( $h2->{$2} ) ){
      $h2->{$2}++;
    } else {
      $h2->{$2} = 1;
    }
  }
}

foreach my $name (keys %$h2) {
  my $ip = `dig $name | grep '^$name' | awk '{print \$5}'`;
  chomp $ip;
  $h3->{$ip} = $name;
}

my $sql = 'SELECT a.ip, b.count, n.h323_id 
        FROM ( SELECT substring_index(an_address,":",1) as ip FROM `porta-sip`.active_nodes WHERE an_env = 1 AND an_expires > NOW() AND an_address NOT REGEXP "^91\.121\.122\.64" ) a 
        LEFT JOIN ( SELECT COUNT(username) as count, domain FROM `porta-sip`.location WHERE expires > NOW() GROUP BY domain ) b ON a.ip=b.domain 
        LEFT JOIN `porta-billing`.Nodes n ON a.ip = n.ip WHERE b.count IS NOT NULL ORDER BY count;';

my $sth = $pb_dbh->prepare($sql);
$sth->execute();
my $c1 = 0;
my $c2 = 0;
while ( my $row = $sth->fetchrow_hashref ){
  if ( defined($h3->{$row->{'ip'}}) ){
    $h4->{$h3->{$row->{'ip'}}} = $row->{'count'};
    $c1 = $c1 + $row->{'count'};
    $c2 = max $c2, $row->{'count'};
  }
}

my $c3 = 0;

foreach my $a (keys %$h4) {
  foreach my $s (keys %$h1) {
    if ( $h1->{$s} eq $a ){
      my $t =  ($c2 - $h4->{$a} ) / $h2->{$a};
      $h6->{$s} = $t;
      $c3 = $c3 +$t;
    }
  }
}


foreach my $s (keys $h6) {
  my $w = int( ( $h6->{$s}*100/$c3 ) + 0.5 );
  my $sql = "INSERT INTO Sip_Servers (name,weight,timestamp) VALUES ('$s',$w,".$timestamp.") ON DUPLICATE KEY UPDATE weight = $w, timestamp = $timestamp;";
  print "$sql\n";
  $sth = $pr_dbh->prepare($sql);
  $sth->execute();
}

$sql = "SELECT MAX(timestamp) as max FROM Sip_Servers;";
$sth = $pr_dbh->prepare($sql);
$sth->execute();
my $max = 0;
while ( my $row = $sth->fetchrow_hashref ){
  $max = $row->{'max'};
}
if (  $max != 0 ){
  $sql = "DELETE FROM Sip_Servers WHERE timestamp < ".$max.";"; 
  $sth = $pr_dbh->prepare($sql);
  $sth->execute();
}

$pr_dbh->disconnect();
$pb_dbh->disconnect();
